# Copyright (c) 2002
#	Riverbank Computing Limited <info@riverbankcomputing.co.uk>
#       Jim Bublitz <jbublitz@nwinternet.com>

TEMPLATE = lib
TARGET = @BL_TARGET@
DESTDIR = @BL_DESTDIR@
CONFIG += qt warn_off release dll @BL_THREAD@
INCLUDEPATH = -I ../extraH @BL_INCLUDEPATH@ -I /usr/X11R6/include
DEFINES = SIP_MAKE_MODULE_DLL @BL_DEFINES@

unix:LIBS += -L@BL_SIPMODDIR@ -L@BL_KDEDIR@ -lsip -lqtcmodule -lDCOP -lkdecore -ldcopcmodule

SOURCES = \
	kdecorecmodule.cpp \
	sipkdecoreULongValueList.cpp \
	sipkdecoreUIntValueList.cpp \
	sipkdecoreNETIcon.cpp \
	sipkdecoreKStringMap.cpp \
	sipkdecoreKProcessList.cpp \
	sipkdecoreKeyBindingMap.cpp \
	sipkdecoreKEntryMap.cpp \
	sipkdecoreMD5Digest.cpp \
	sipkdecoreKComplMatches.cpp \
	sipkdecoreIntValueList.cpp \
	sipkdecoreDisplay.cpp \
	sipkdecoreNETStrut.cpp \
	sipkdecoreNETRect.cpp \
	sipkdecoreNETSize.cpp \
	sipkdecoreNETPoint.cpp \
	sipkdecoreNETWinInfo.cpp \
	sipkdecoreNET.cpp \
	sipkdecoreNETRootInfo.cpp \
	sipkdecoreKWinModule.cpp \
	sipkdecoreKWinInfo.cpp \
	sipkdecoreKWin.cpp \
	sipkdecoreKURLDrag.cpp \
	sipkdecoreKURLList.cpp \
	sipkdecoreKURL.cpp \
	sipkdecoreKUniqueApplication.cpp \
	sipkdecoreKTempFile.cpp \
	sipkdecoreKSycocaFactory.cpp \
	sipkdecoreKSycocaEntry.cpp \
	sipkdecoreKSycocaDict.cpp \
	sipkdecoreKSycoca.cpp \
	sipkdecoreKStringHandler.cpp \
	sipkdecoreKStaticDeleterBase.cpp \
	sipkdecoreKStartupInfoId.cpp \
	sipkdecoreKStartupInfoData.cpp \
	sipkdecoreKStartupInfo.cpp \
	sipkdecoreKStandardDirs.cpp \
	sipkdecoreKServerSocket.cpp \
	sipkdecoreKSocket.cpp \
	sipkdecoreKSimpleConfig.cpp \
	sipkdecoreKStdAccelShortcutList.cpp \
	sipkdecoreKShortcutList.cpp \
	sipkdecoreKAccelShortcutList.cpp \
	sipkdecoreKShortcut.cpp \
	sipkdecoreKKeySequence.cpp \
	sipkdecoreKKey.cpp \
	sipkdecoreKShared.cpp \
	sipkdecoreKSaveFile.cpp \
	sipkdecoreKRootProp.cpp \
	sipkdecoreKRFCDate.cpp \
	sipkdecoreKRegExp.cpp \
	sipkdecoreKRandomSequence.cpp \
	sipkdecoreKProcIO.cpp \
	sipkdecoreKShellProcess.cpp \
	sipkdecoreKProcess.cpp \
	sipkdecoreKProcessController.cpp \
	sipkdecoreKPixmapProvider.cpp \
	sipkdecoreKPalette.cpp \
	sipkdecoreKNotifyClientInstance.cpp \
	sipkdecoreKMultipleDrag.cpp \
	sipkdecoreKMimeSourceFactory.cpp \
	sipkdecoreKMD5.cpp \
	sipkdecoreKCodecs.cpp \
	sipkdecoreKLocale.cpp \
	sipkdecoreKLibLoader.cpp \
	sipkdecoreKLibrary.cpp \
	sipkdecoreKLibFactory.cpp \
	sipkdecoreKKeyServerVariations.cpp \
	sipkdecoreKKeyServerKey.cpp \
	sipkdecoreKKeyServerSym.cpp \
	sipkdecoreKKeyNative.cpp \
	sipkdecoreKIPC.cpp \
	sipkdecoreKInstance.cpp \
	sipkdecoreKIconTheme.cpp \
	sipkdecoreKIcon.cpp \
	sipkdecoreKIconEffect.cpp \
	sipkdecoreKGlobalSettings.cpp \
	sipkdecoreKGlobalAccel.cpp \
	sipkdecoreKGlobal.cpp \
	sipkdecoreKDesktopFile.cpp \
	sipkdecoreKDCOPPropertyProxy.cpp \
	sipkdecoreKCrash.cpp \
	sipkdecoreKEntry.cpp \
	sipkdecoreKEntryKey.cpp \
	sipkdecoreKConfigGroup.cpp \
	sipkdecoreKConfigGroupSaver.cpp \
	sipkdecoreKConfigINIBackEnd.cpp \
	sipkdecoreKConfigBackEnd.cpp \
	sipkdecoreKConfigBase.cpp \
	sipkdecoreKConfig.cpp \
	sipkdecoreKCompletionBase.cpp \
	sipkdecoreKCompletion.cpp \
	sipkdecoreKCmdLineOptions.cpp \
	sipkdecoreKCmdLineArgs.cpp \
	sipkdecoreKCharsets.cpp \
	sipkdecoreKCatalogue.cpp \
	sipkdecoreKBufferedIO.cpp \
	sipkdecoreKAudioPlayer.cpp \
	sipkdecoreKAsyncIO.cpp \
	sipkdecoreKAccelBase.cpp \
	sipkdecoreKSessionManaged.cpp \
	sipkdecoreKApplication.cpp \
	sipkdecoreKAccelActions.cpp \
	sipkdecoreKAccelAction.cpp \
	sipkdecoreKAccel.cpp \
	sipkdecoreKAboutData.cpp \
	sipkdecoreKAboutTranslator.cpp \
	sipkdecoreKAboutPerson.cpp \
	sipkdecoreKIconLoader.cpp

HEADERS = \
	sipkdecoreDeclkdecore.h sipkdecoreProxykdecore.h \
	sipkdecoreULongValueList.h \
	sipkdecoreUIntValueList.h \
	sipkdecoreNETIcon.h \
	sipkdecoreKStringMap.h \
	sipkdecoreKProcessList.h \
	sipkdecoreKeyBindingMap.h \
	sipkdecoreKEntryMap.h \
	sipkdecoreMD5Digest.h \
	sipkdecoreKComplMatches.h \
	sipkdecoreIntValueList.h \
	sipkdecoreDisplay.h \
	sipkdecoreNETStrut.h \
	sipkdecoreNETRect.h \
	sipkdecoreNETSize.h \
	sipkdecoreNETPoint.h \
	sipkdecoreNETWinInfo.h \
	sipkdecoreNET.h \
	sipkdecoreNETRootInfo.h \
	sipkdecoreKWinModule.h \
	sipkdecoreKWinInfo.h \
	sipkdecoreKWin.h \
	sipkdecoreKURLDrag.h \
	sipkdecoreKURLList.h \
	sipkdecoreKURL.h \
	sipkdecoreKUniqueApplication.h \
	sipkdecoreKTempFile.h \
	sipkdecoreKSycocaFactory.h \
	sipkdecoreKSycocaEntry.h \
	sipkdecoreKSycocaDict.h \
	sipkdecoreKSycoca.h \
	sipkdecoreKStringHandler.h \
	sipkdecoreKStaticDeleterBase.h \
	sipkdecoreKStartupInfoId.h \
	sipkdecoreKStartupInfoData.h \
	sipkdecoreKStartupInfo.h \
	sipkdecoreKStandardDirs.h \
	sipkdecoreKServerSocket.h \
	sipkdecoreKSocket.h \
	sipkdecoreKSimpleConfig.h \
	sipkdecoreKStdAccelShortcutList.h \
	sipkdecoreKShortcutList.h \
	sipkdecoreKAccelShortcutList.h \
	sipkdecoreKShortcut.h \
	sipkdecoreKKeySequence.h \
	sipkdecoreKKey.h \
	sipkdecoreKShared.h \
	sipkdecoreKSaveFile.h \
	sipkdecoreKRootProp.h \
	sipkdecoreKRFCDate.h \
	sipkdecoreKRegExp.h \
	sipkdecoreKRandomSequence.h \
	sipkdecoreKProcIO.h \
	sipkdecoreKShellProcess.h \
	sipkdecoreKProcess.h \
	sipkdecoreKProcessController.h \
	sipkdecoreKPixmapProvider.h \
	sipkdecoreKPalette.h \
	sipkdecoreKNotifyClientInstance.h \
	sipkdecoreKMultipleDrag.h \
	sipkdecoreKMimeSourceFactory.h \
	sipkdecoreKMD5.h \
	sipkdecoreKCodecs.h \
	sipkdecoreKLocale.h \
	sipkdecoreKLibLoader.h \
	sipkdecoreKLibrary.h \
	sipkdecoreKLibFactory.h \
	sipkdecoreKKeyServerVariations.h \
	sipkdecoreKKeyServerKey.h \
	sipkdecoreKKeyServerSym.h \
	sipkdecoreKKeyNative.h \
	sipkdecoreKIPC.h \
	sipkdecoreKInstance.h \
	sipkdecoreKIconTheme.h \
	sipkdecoreKIcon.h \
	sipkdecoreKIconEffect.h \
	sipkdecoreKGlobalSettings.h \
	sipkdecoreKGlobalAccel.h \
	sipkdecoreKGlobal.h \
	sipkdecoreKDesktopFile.h \
	sipkdecoreKDCOPPropertyProxy.h \
	sipkdecoreKCrash.h \
	sipkdecoreKEntry.h \
	sipkdecoreKEntryKey.h \
	sipkdecoreKConfigGroup.h \
	sipkdecoreKConfigGroupSaver.h \
	sipkdecoreKConfigINIBackEnd.h \
	sipkdecoreKConfigBackEnd.h \
	sipkdecoreKConfigBase.h \
	sipkdecoreKConfig.h \
	sipkdecoreKCompletionBase.h \
	sipkdecoreKCompletion.h \
	sipkdecoreKCmdLineOptions.h \
	sipkdecoreKCmdLineArgs.h \
	sipkdecoreKCharsets.h \
	sipkdecoreKCatalogue.h \
	sipkdecoreKBufferedIO.h \
	sipkdecoreKAudioPlayer.h \
	sipkdecoreKAsyncIO.h \
	sipkdecoreKAccelBase.h \
	sipkdecoreKSessionManaged.h \
	sipkdecoreKApplication.h \
	sipkdecoreKAccelActions.h \
	sipkdecoreKAccelAction.h \
	sipkdecoreKAccel.h \
	sipkdecoreKAboutData.h \
	sipkdecoreKAboutTranslator.h \
	sipkdecoreKAboutPerson.h \
	sipkdecoreKIconLoader.h \
	sipdcopQCStringList.h \
	sipdcopDCOPObject.h \
	sipdcopDCOPClient.h \
	sipdcopDCOPClientTransaction.h \
	sipqtQWMatrix.h \
	sipqtQWidgetList.h \
	sipqtQVariant.h \
	sipqtQValueList.h \
	sipqtQValidator.h \
	sipqtQUrlOperator.h \
	sipqtQUrlInfo.h \
	sipqtQUrl.h \
	sipqtQTranslator.h \
	sipqtQTranslatorMessage.h \
	sipqtQToolTipGroup.h \
	sipqtQToolButton.h \
	sipqtQToolBar.h \
	sipqtQTextStream.h \
	sipqtQTextCursor.h \
	sipqtQTextDocument.h \
	sipqtQTextCodec.h \
	sipqtQTextDecoder.h \
	sipqtQTextEncoder.h \
	sipqtQTabBar.h \
	sipqtQTab.h \
	sipqtQStyleSheet.h \
	sipqtQStyleSheetItem.h \
	sipqtQStyleHintReturn.h \
	sipqtQStyleOption.h \
	sipqtQStrList.h \
	sipqtQStringList.h \
	sipqtQString.h \
	sipqtQChar.h \
	sipqtQStatusBar.h \
	sipqtQSessionManager.h \
	sipqtQScrollBar.h \
	sipqtQRegion.h \
	sipqtQRegExp.h \
	sipqtQRect.h \
	sipqtQPushButton.h \
	sipqtQPtrList.h \
	sipqtQProgressBar.h \
	sipqtQPrinter.h \
	sipqtQPopupMenu.h \
	sipqtQPointArray.h \
	sipqtQPoint.h \
	sipqtQWindowsStyle.h \
	sipqtQPicture.h \
	sipqtQPalette.h \
	sipqtQPair.h \
	sipqtQPainter.h \
	sipqtQObjectList.h \
	sipqtQNetworkOperation.h \
	sipqtQNetworkProtocol.h \
	sipqtQNetworkProtocolFactoryBase.h \
	sipqtQTextEdit.h \
	sipqtQMovie.h \
	sipqtQMimeSourceFactory.h \
	sipqtQCustomMenuItem.h \
	sipqtQMenuItem.h \
	sipqtQMenuData.h \
	sipqtQMenuBar.h \
	sipqtQMainWindow.h \
	sipqtQListView.h \
	sipqtQListViewItem.h \
	sipqtQListBoxItem.h \
	sipqtQListBox.h \
	sipqtQLineEdit.h \
	sipqtQHBoxLayout.h \
	sipqtQBoxLayout.h \
	sipqtQLayout.h \
	sipqtQSpacerItem.h \
	sipqtQLayoutItem.h \
	sipqtQLayoutIterator.h \
	sipqtQGLayoutIterator.h \
	sipqtQLabel.h \
	sipqtQKeySequence.h \
	sipqtQImageTextKeyLang.h \
	sipqtQImage.h \
	sipqtQIconView.h \
	sipqtQIconViewItem.h \
	sipqtQIconDragItem.h \
	sipqtQIconSet.h \
	sipqtQHeader.h \
	sipqtQHBox.h \
	sipqtQScrollView.h \
	sipqtQFontMetrics.h \
	sipqtQFontInfo.h \
	sipqtQFont.h \
	sipqtQFileInfo.h \
	sipqtQFilePreview.h \
	sipqtQFileIconProvider.h \
	sipqtQIODevice.h \
	sipqtQFile.h \
	sipqtQCustomEvent.h \
	sipqtQChildEvent.h \
	sipqtQDragLeaveEvent.h \
	sipqtQDragEnterEvent.h \
	sipqtQDragMoveEvent.h \
	sipqtQDropEvent.h \
	sipqtQIMEvent.h \
	sipqtQContextMenuEvent.h \
	sipqtQHideEvent.h \
	sipqtQShowEvent.h \
	sipqtQCloseEvent.h \
	sipqtQResizeEvent.h \
	sipqtQMoveEvent.h \
	sipqtQPaintEvent.h \
	sipqtQFocusEvent.h \
	sipqtQKeyEvent.h \
	sipqtQTabletEvent.h \
	sipqtQWheelEvent.h \
	sipqtQMouseEvent.h \
	sipqtQTimerEvent.h \
	sipqtQEvent.h \
	sipqtQStoredDrag.h \
	sipqtQMimeSource.h \
	sipqtQDragObject.h \
	sipqtQFrame.h \
	sipqtQDockWindow.h \
	sipqtQDockArea.h \
	sipqtQDir.h \
	sipqtQFileInfoList.h \
	sipqtQRangeControl.h \
	sipqtQDesktopWidget.h \
	sipqtQTimeEdit.h \
	sipqtQDateEdit.h \
	sipqtQDateTime.h \
	sipqtQTime.h \
	sipqtQDate.h \
	sipqtQDataStream.h \
	sipqtQCursor.h \
	sipqtQCString.h \
	sipqtQStyle.h \
	sipqtQCommonStyle.h \
	sipqtQComboBox.h \
	sipqtQColorGroup.h \
	sipqtQDialog.h \
	sipqtQColor.h \
	sipqtQClipboard.h \
	sipqtQMotifStyle.h \
	sipqtQByteArray.h \
	sipqtQGroupBox.h \
	sipqtQButtonGroup.h \
	sipqtQWidget.h \
	sipqtQButton.h \
	sipqtQBrush.h \
	sipqtQApplication.h \
	sipqtQAction.h \
	sipqtQObject.h \
	sipqtQSizePolicy.h \
	sipqtQSize.h \
	sipqtQBitmap.h \
	sipqtQPixmap.h \
	sipqtQPaintDevice.h \
	sipqtQPen.h \
	sipqtQt.h

