// C++ interface wrapper code.
//
// Generated by SIP snapshot-20030204 (build 65) on Sun Mar 16 13:45:47 2003
//
// Terms and Conditions
// 
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
// COPYRIGHT HOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
// IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// 
// Except as contained in this notice, the name of the copyright holder shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from the
// copyright holder.

#include "sipkdecoreDeclkdecore.h"
#include "sipkdecoreKStringMap.h"


int sipConvertTo_KStringMap(PyObject *sipPy,KStringMap **sipCppPtr,int *sipIsErr)
{
#line 61 "sip/kstringmap.sip"
	// Convert a Python dictionary to a KStringMap on the heap.

	if (sipIsErr == NULL)
		return PyDict_Check(sipPy);


	KStringMap *map = new KStringMap;

        PyObject *key, *value;
        int pos = 0;
        QString *sKey;
        QString *sData;

        while (PyDict_Next(sipPy, &pos, &key, &value))
        {
                int iserr = 0;

                sipConvertTo_QString (key, &sKey, &iserr);
                sipConvertTo_QString (key, &sData, &iserr);

                if (iserr)
                {
                        *sipIsErr = 1;
                        delete map;
                        return 0;
                }

                map->insert (*sKey, *sData);
        }

	*sipCppPtr = map;

	return 1;
#line 72 "sipkdecoreKStringMap.cpp"
}

KStringMap *sipForceConvertTo_KStringMap(PyObject *valobj,int *iserrp)
{
	if (*iserrp || valobj == NULL)
		return NULL;

	if (sipConvertTo_KStringMap(valobj,NULL,NULL))
	{
		KStringMap *val;

		sipConvertTo_KStringMap(valobj,&val,iserrp);

		return val;
	}

	sipBadClass(sipName_kdecore_KStringMap);

	*iserrp = 1;

	return NULL;
}

PyObject *sipConvertFrom_KStringMap(KStringMap *sipCpp)
{
#line 26 "sip/kstringmap.sip"
	// Convert to a Python list of strings.

	if (!sipCpp)
		return PyDict_New();

        PyObject *dict;

	// Create the dictionary.

	if ((dict = PyDict_New()) == NULL)
		return NULL;

	// Get it.

        const KStringMap map = *sipCpp;
        KStringMap::ConstIterator it;

	for (it = map.begin (); it != map.end (); ++it)
        {
                PyObject *sKey  = PyString_FromString ((char *)((QString *)&it.key ()));
                PyObject *sData = PyString_FromString ((char *)((QString *)&it.data ()));

                if ((sKey == NULL) || (sData == NULL) || (PyDict_SetItem (dict, sKey, sData) < 0))
                {
                        Py_XDECREF (sKey);
                        Py_XDECREF (sData);
                        Py_DECREF (dict);
                        return NULL;
                }
        }

	return dict;
#line 131 "sipkdecoreKStringMap.cpp"
}
