// C++ interface wrapper code.
//
// Generated by SIP snapshot-20030204 (build 65) on Sun Mar 16 13:45:47 2003
//
// Terms and Conditions
// 
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
// COPYRIGHT HOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
// IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// 
// Except as contained in this notice, the name of the copyright holder shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from the
// copyright holder.

#include "sipkdecoreDeclkdecore.h"
#include "sipkdecoreKeyBindingMap.h"


int sipConvertTo_KeyBindingMap(PyObject *sipPy,KeyBindingMap **sipCppPtr,int *sipIsErr)
{
#line 65 "sip/keybindingmap.sip"
	// Convert a Python dictionary to a KeyBindingMap on the heap.

	if (sipIsErr == NULL)
		return PyDict_Check(sipPy);

	KeyBindingMap *kbmap = new KeyBindingMap;

        PyObject *key, *value;
        int pos = 0;
        KShortcut *cValue;
        int iserr;

        while (PyDict_Next(sipPy, &pos, &key, &value))
        {
                cValue = sipForceConvertTo_KShortcut (value, &iserr);
                if (iserr || !PyInt_Check (key))
                {
                        *sipIsErr = 1;
                        delete kbmap;
                        return 0;
                }

                kbmap->insert ((KCompletionBase::KeyBindingType)PyInt_AS_LONG (key), *cValue);
        }

	*sipCppPtr = kbmap;

	return 1;
#line 67 "sipkdecoreKeyBindingMap.cpp"
}

KeyBindingMap *sipForceConvertTo_KeyBindingMap(PyObject *valobj,int *iserrp)
{
	if (*iserrp || valobj == NULL)
		return NULL;

	if (sipConvertTo_KeyBindingMap(valobj,NULL,NULL))
	{
		KeyBindingMap *val;

		sipConvertTo_KeyBindingMap(valobj,&val,iserrp);

		return val;
	}

	sipBadClass(sipName_kdecore_KeyBindingMap);

	*iserrp = 1;

	return NULL;
}

PyObject *sipConvertFrom_KeyBindingMap(KeyBindingMap *sipCpp)
{
#line 26 "sip/keybindingmap.sip"
	// Convert to a Python list of strings.

	if (!sipCpp)
		return PyDict_New();

        PyObject *dict;

	// Create the dictionary.

	if ((dict = PyDict_New()) == NULL)
		return NULL;

	// Get it.

        const KeyBindingMap map = *sipCpp;
        KeyBindingMap::ConstIterator it;

        PyObject *key;
        PyObject *value;

	for (it = map.begin (); it != map.end (); ++it)
        {
                key   = PyInt_FromLong ((int) it.key ());
                value = sipMapCppToSelf (&it.data (), sipClass_KShortcut);
                if ((value == NULL) || (PyDict_SetItem (dict, key, value) < 0))
                {
                        Py_XDECREF (key);
                        Py_XDECREF (value);
                        Py_DECREF (dict);
                        return NULL;
                }
        }


	return dict;
#line 129 "sipkdecoreKeyBindingMap.cpp"
}
